package body Contenedores.rboles_Binarios.Ajustables is
	procedure Rotar_simple(P: in out Rbol_bin_Bus; Haca: in Orientacin) is
		Rama    : Integer := Orientacin'Pos(Haca) + 1;
		OtraRama: Integer := 3 - Rama;
		Hijo    : Rbol_bin_Bus := P.Hijos(Rama);
	begin
		P.Hijos(Rama)        := Hijo.Hijos(OtraRama);
		Hijo.Hijos(OtraRama) := P;
		P                    := Hijo;
	end Rotar_Simple;

	procedure Rotar_Doble(A: in out Rbol_bin_Bus; Haca: in Orientacin) is
		Rama    : Integer := Orientacin'Pos(Haca) + 1;
		OtraRama: Integer := 3 - Rama;
		Hijo    : Rbol_bin_Bus := A.Hijos(Rama);
		Nieto   : Rbol_bin_Bus := Hijo.Hijos(OtraRama);
	begin
		A.Hijos(Rama)         := Nieto.Hijos(OtraRama);
		Hijo.Hijos(OtraRama)  := Nieto.Hijos(Rama);
		Nieto.Hijos(OtraRama) := A;
 	    Nieto.Hijos(Rama)     := Hijo;
		A                     := Nieto;
	end Rotar_Doble;

	procedure Rotar_Doble_Inversora(A: in out Rbol_bin_Bus; Haca: in Orientacin) is
		Rama    : Integer := Orientacin'Pos(Haca) + 1;
		OtraRama: Integer := 3 - Rama;
		Hijo    : Rbol_bin_Bus   := A.Hijos(Rama);
		Nieto   : Rbol_bin_Bus   := Hijo.Hijos(Rama);
	begin
		A.Hijos(Rama)         := Hijo.Hijos(OtraRama);
		Hijo.Hijos(Rama)      := Nieto.Hijos(OtraRama);
		Nieto.Hijos(OtraRama) := Hijo;
		Hijo.Hijos(OtraRama)  := A;
		A := Nieto;
	end Rotar_Doble_inversora;
	
end Contenedores.rboles_Binarios.Ajustables;
