#ifndef INC_BINARIOBUSQUEDABASICO
#define INC_BINARIOBUSQUEDABASICO
#include "..\comun\contenedor.h"

template <class T, class P>
class BinarioBusquedaBasico:public Contenedor<T> {
   protected:
      int numElem;
      bool buscarInterno(P *, const T&) const;
      void eliminarInterno(P *&);
   public:
      BinarioBusquedaBasico() {numElem=0;}
      virtual ~BinarioBusquedaBasico() {};
      int cardinal() const {return numElem;}
};


// Funciones miembro de la clase BinarioBusquedaBasico
template <class T, class P>
   bool BinarioBusquedaBasico<T,P>::buscarInterno(P *nodo,const T& valor)const
   {
      while (nodo!=NULL)
         if(valor==nodo->clave)
            return true;
         else
            if(valor<nodo->clave)
               nodo=nodo->enlaces[0];
            else
               nodo=nodo->enlaces[1];
      return false;
   }

template <class T, class P>
   void BinarioBusquedaBasico<T,P>::eliminarInterno(P *&nodo)
   {
      if(nodo!=NULL)
      {
         eliminarInterno(nodo->enlaces[0]);
         eliminarInterno(nodo->enlaces[1]);
         delete nodo;
      }
   }

#endif



